The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::VoicForm Class Reference

Four formant synthesis instrument. More...

`#include <VoicForm.h>`

Inheritance diagram for stk::VoicForm:

## Public Member Functions
| VoicForm (void)
| Class constructor.
| ~VoicForm (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
bool | setPhoneme (const char *phoneme)
| Set instrument parameters for the given phoneme. Returns false if phoneme not found.
void | setVoiced (StkFloat vGain)
| Set the voiced component gain.
void | setUnVoiced (StkFloat nGain)
| Set the unvoiced component gain.
void | setFilterSweepRate (unsigned int whichOne, StkFloat rate)
| Set the sweep rate for a particular formant filter (0-3).
void | setPitchSweepRate (StkFloat rate)
| Set voiced component pitch sweep rate.
void | speak (void)
| Start the voice.
void | quiet (void)
| Stop the voice.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Instrmnt
| Instrmnt (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

Four formant synthesis instrument.

This instrument contains an excitation singing wavetable (looping wave with random and periodic vibrato, smoothing on frequency, etc.), excitation noise, and four sweepable complex resonances.

Measured formant data is included, and enough data is there to support either parallel or cascade synthesis. In the floating point case cascade synthesis is the most natural so that's what you'll find here.

Control Change Numbers:

- Voiced/Unvoiced Mix = 2
- Vowel/Phoneme Selection = 4
- Vibrato Frequency = 11
- Vibrato Gain = 1
- Loudness (Spectral Tilt) = 128

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ VoicForm()

stk::VoicForm::VoicForm | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

## ◆ tick()

StkFrames & stk::VoicForm::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = 0 )
| inlinevirtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

133{
134 unsigned int nChannels = lastFrame_.channels();
135#if defined(_STK_DEBUG_)
136 if ( channel > frames.channels() - nChannels ) {
137 oStream_ << "VoicForm::tick(): channel and StkFrames arguments are incompatible!";
138 handleError( StkError::FUNCTION_ARGUMENT );
139 }
140#endif
141
142 StkFloat *samples = &frames[channel];
143 unsigned int j, hop = frames.channels() - nChannels;
144 if ( nChannels == 1 ) {
145 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
146 *samples++ = tick();
147 }
148 else {
149 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
150 *samples++ = tick();
151 for ( j=1; j<nChannels; j++ )
152 *samples++ = lastFrame_[j];
153 }
154 }
155
156 return frames;
157}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::VoicForm::tick
StkFloat tick(unsigned int channel=0)
Compute and return one output sample.
Definition VoicForm.h:113

The documentation for this class was generated from the following file:

- VoicForm.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.